# GeometryUpdater

#### new Cesium.GeometryUpdater(options)
DataSources/GeometryUpdater.js 39

An abstract class for updating geometry entities.

Name | Type | Description
--- | --- | ---

`options`

Object

An object with the following properties:

Name | Type | Description
--- | --- | ---
`entity` | Entity | The entity containing the geometry to be visualized.
`scene` | Scene | The scene where visualization is taking place.
`geometryOptions` | Object | Options for the geometry
`geometryPropertyName` | String | The geometry property name
`observedPropertyNames` | Array.<String> | The entity properties this geometry cares about

### Members

#### readonly classificationTypeProperty : Property
DataSources/GeometryUpdater.js 215

Gets or sets the `ClassificationType` Property specifying if this geometry will classify terrain, 3D Tiles, or both when on the ground.

#### readonly distanceDisplayConditionProperty : Property
DataSources/GeometryUpdater.js 203

Gets or sets the `DistanceDisplayCondition` Property specifying at what distance from the camera that this geometry will be displayed.

#### readonly entity : Entity
DataSources/GeometryUpdater.js 93

Gets the entity associated with this geometry.

#### readonly fillEnabled : Boolean
DataSources/GeometryUpdater.js 105

Gets a value indicating if the geometry has a fill component.

#### readonly fillMaterialProperty : MaterialProperty
DataSources/GeometryUpdater.js 129

Gets the material property used to fill the geometry.

#### readonly geometryChanged : Boolean
DataSources/GeometryUpdater.js 267

Gets an event that is raised whenever the public properties of this updater change.

#### readonly hasConstantFill : Boolean
DataSources/GeometryUpdater.js 117

Gets a value indicating if fill visibility varies with simulation time.

#### readonly hasConstantOutline : Boolean
DataSources/GeometryUpdater.js 153

Gets a value indicating if the geometry has an outline component.

#### readonly id : String
DataSources/GeometryUpdater.js 81

Gets the unique ID associated with this updater

#### readonly isClosed : Boolean
DataSources/GeometryUpdater.js 242

Gets a value indicating if the geometry is closed. This property is only valid for static geometry.

#### readonly isDynamic : Boolean
DataSources/GeometryUpdater.js 229

Gets a value indicating if the geometry is time-varying. If true, all visualization is delegated to a DynamicGeometryUpdater returned by GeometryUpdater#createDynamicUpdater.

#### readonly outlineColorProperty : Property
DataSources/GeometryUpdater.js 165

Gets the `Color` property for the geometry outline.

#### readonly outlineEnabled : Boolean
DataSources/GeometryUpdater.js 141

Gets a value indicating if the geometry has an outline component.

#### readonly outlineWidth : Number
DataSources/GeometryUpdater.js 178

Gets the constant with of the geometry outline, in pixels. This value is only valid if isDynamic is false.

#### readonly shadowsProperty : Property
DataSources/GeometryUpdater.js 191

Gets the property specifying whether the geometry casts or receives shadows from light sources.

### Methods

#### createFillGeometryInstance(time) → GeometryInstance
DataSources/GeometryUpdater.js 307

Creates the geometry instance which represents the fill of the geometry.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time to use when retrieving initial attribute values.

##### Returns:

The geometry instance representing the filled portion of the geometry.

##### Throws:

- DeveloperError : This instance does not represent a filled geometry.

#### createOutlineGeometryInstance(time) → GeometryInstance
DataSources/GeometryUpdater.js 318

Creates the geometry instance which represents the outline of the geometry.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time to use when retrieving initial attribute values.

##### Returns:

The geometry instance representing the outline portion of the geometry.

##### Throws:

- DeveloperError : This instance does not represent an outlined geometry.

#### destroy()
DataSources/GeometryUpdater.js 334

Destroys and resources used by the object. Once an object is destroyed, it should not be used.

##### Throws:

- DeveloperError : This object was destroyed, i.e., destroy() was called.

#### isDestroyed() → Boolean
DataSources/GeometryUpdater.js 325

Returns true if this object was destroyed; otherwise, false.

##### Returns:

True if this object was destroyed; otherwise, false.

#### isFilled(time) → Boolean
DataSources/GeometryUpdater.js 292

Checks if the geometry is filled at the provided time.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time for which to retrieve visibility.

##### Returns:

true if geometry is filled at the provided time, false otherwise.

#### isOutlineVisible(time) → Boolean
DataSources/GeometryUpdater.js 280

Checks if the geometry is outlined at the provided time.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time for which to retrieve visibility.

##### Returns:

true if geometry is outlined at the provided time, false otherwise.